(function(ns) {
    var _earth = null,
        _dataProcess = null,
        _data = {};


    //main
    function _initDraw(earth, dataProcess) {
        _earth = earth;
        _dataProcess = dataProcess



        _initUI();
        _addEventListeners();
    }

    function _destroyDraw() {
        _removeEventListeners();
    }

    function _initUI() {

    }

    function _addEventListeners() {
        $('#drawPanel').find('#sphere').bind('click', function(e) {
            _earth.Event.OnCreateGeometry = function(pval, type) {
                _earth.Event.OnCreateGeometry = function() {};
                if (top.console) {
                    top.console.log('sphere pval.Rtti:' + pval.Rtti);
                    top.console.log('sphere type:' + type);
                    top.console.log('-----------------------------------');
                }
                if (pval) {
                    var guid = _earth.Factory.CreateGUID();
                    var elementSphere = _earth.Factory.CreateElementSphere(guid, '球');
                    elementSphere.BeginUpdate();
                    elementSphere.Selectable = true;
                    elementSphere.Editable = true;
                    elementSphere.Underground = false;
                    elementSphere.SphericalTransform.SetLocationEx(pval.Longitude, pval.Latitude, pval.Altitude);
                    elementSphere.Radius = pval.Radius;
                    elementSphere.FillColor = parseInt("0xccc0c0c0");
                    elementSphere.EndUpdate();
                    _earth.AttachObject(elementSphere);
                    _earth.ShapeCreator.Clear();
                }
            };
            _earth.ShapeCreator.CreateSphere(16711680);
        });

        $('#drawPanel').find('#box').bind('click', function(e) {
            _earth.Event.OnCreateGeometry = function(pval, type) {
                _earth.Event.OnCreateGeometry = function() {};
                if (top.console) {
                    top.console.log('box pval.Rtti:' + pval.Rtti);
                    top.console.log('box type:' + type);
                    top.console.log('-----------------------------------');
                }
                if (pval) {
                    var guid = _earth.Factory.CreateGUID();
                    var elementBox = _earth.Factory.CreateElementBox(guid, '立方体');
                    elementBox.BeginUpdate();
                    elementBox.Selectable = true;
                    elementBox.Editable = true;
                    elementBox.Underground = false;
                    elementBox.SphericalTransform.SetLocationEx(pval.Longitude, pval.Latitude, pval.Altitude);
                    elementBox.Length = pval.Length;
                    elementBox.Width = pval.Width;
                    elementBox.Height = pval.Height;
                    elementBox.FillColor = parseInt("0xccc0c0c0");
                    elementBox.EndUpdate();
                    _earth.AttachObject(elementBox);
                    _earth.ShapeCreator.Clear();
                }
            };
            _earth.ShapeCreator.CreateBox(16711680);
        });

        $('#drawPanel').find('#volume').bind('click', function(e) {
            _earth.Event.OnCreateGeometry = function(pval, type) {
                 _earth.Event.OnCreateGeometry = function() {};
                if (top.console) {
                    top.console.log('volume pval.Rtti:' + pval.Rtti);
                    top.console.log('volume type:' + type);
                    top.console.log('-----------------------------------');
                }
                if (pval) {
                    var guid = _earth.Factory.CreateGUID();
                    var elementVolume = _earth.Factory.CreateElementVolume(guid, '立体多边形');
                    elementVolume.BeginUpdate();
                    elementVolume.Selectable = true;
                    elementVolume.Editable = true;
                    elementVolume.Underground = false;
                    elementVolume.SphericalTransform.SetLocationEx(pval.Longitude, pval.Latitude, pval.Altitude);
                    elementVolume.Height = pval.Height;
                    elementVolume.Vectors = pval.Vector3s;
                    elementVolume.FillColor = parseInt("0xccc0c0c0");
                    polyCount = pval.Vector3s.Count + 2;
                    elementVolume.EndUpdate();
                    _earth.AttachObject(elementVolume);
                    _earth.ShapeCreator.Clear();
                }
            };
            _earth.ShapeCreator.CreateVolume(16711680);
        });

        $('#drawPanel').find('#cone').bind('click', function(e) {
            _earth.Event.OnCreateGeometry = function(pval, type) {
                 _earth.Event.OnCreateGeometry = function() {};
                if (top.console) {
                    top.console.log('cone pval.Rtti:' + pval.Rtti);
                    top.console.log('cone type:' + type);
                    top.console.log('-----------------------------------');
                }
                if (pval) {
                    var guid = _earth.Factory.CreateGUID();
                    var elementCone = _earth.Factory.CreateElementCone(guid, '圆台');
                    elementCone.BeginUpdate();
                    elementCone.Selectable = true;
                    elementCone.Editable = true;
                    elementCone.Underground = false;
                    elementCone.SphericalTransform.SetLocationEx(pval.Longitude, pval.Latitude, pval.Altitude);
                    elementCone.BottomRadius = pval.BottomRadius;
                    elementCone.TopRadius = pval.TopRadius;
                    elementCone.Height = pval.Height;
                    elementCone.FillColor = parseInt("0xccc0c0c0");
                    elementCone.EndUpdate();
                    _earth.AttachObject(elementCone);
                    _earth.ShapeCreator.Clear();
                }

            };
            _earth.ShapeCreator.CreateCone(16711680);
        });

        $('#drawPanel').find('#pyramid').bind('click', function(e) {
            _earth.Event.OnCreateGeometry = function(pval, type) {
                if (top.console) {
                    top.console.log('pyramid pval.Rtti:' + pval.Rtti);
                    top.console.log('pyramid type:' + type);
                    top.console.log('-----------------------------------');
                }
                if (pval) {
                    var guid = _earth.Factory.CreateGUID();
                    var elementPyramid = _earth.Factory.CreateElementPyramid(guid, '棱台');
                    elementPyramid.BeginUpdate();
                    elementPyramid.Selectable = true;
                    elementPyramid.Editable = true;
                    elementPyramid.Underground = false;
                    elementPyramid.SphericalTransform.SetLocationEx(pval.Longitude, pval.Latitude, pval.Altitude);
                    elementPyramid.Sides = pval.Sides;
                    elementPyramid.BottomRadius = pval.BottomRadius;
                    elementPyramid.TopRadius = pval.TopRadius;
                    elementPyramid.Height = pval.Height;
                    elementPyramid.FillColor = parseInt("0xccc0c0c0");
                    elementPyramid.EndUpdate();
                    _earth.AttachObject(elementPyramid);
                    _earth.ShapeCreator.Clear();
                }

            };
            _earth.ShapeCreator.CreatePyramid(5, 16711680);
        });


        $('#drawPanel').find('#browse').bind('click', function(e) {
            _earth.ToolManager.SphericalObjectEditTool.Browse();
        });

        $('#drawPanel').find('#select').bind('click', function(e) {
            _earth.ToolManager.SphericalObjectEditTool.Select();
        });

        $('#drawPanel').find('#move').bind('click', function(e) {
            _earth.ToolManager.SphericalObjectEditTool.Move(7);
        });

        $('#drawPanel').find('#scale').bind('click', function(e) {
            _earth.ToolManager.SphericalObjectEditTool.Scale(7);
        });

        $('#drawPanel').find('#rotate').bind('click', function(e) {
            _earth.ToolManager.SphericalObjectEditTool.Rotate(7);
        });
    }

    function _removeEventListeners() {
        $('#drawPanel').find('#sphere').unbind();
        $('#drawPanel').find('#box').unbind();
        $('#drawPanel').find('#volume').unbind();
        $('#drawPanel').find('#cone').unbind();
        $('#drawPanel').find('#pyramid').unbind();

        $('#drawPanel').find('#browse').unbind();
        $('#drawPanel').find('#select').unbind();
        $('#drawPanel').find('#move').unbind();
        $('#drawPanel').find('#scale').unbind();
        $('#drawPanel').find('#rotate').unbind();
    }




    if (!ns.STAMP.initer) {
        ns.STAMP.initer = {};
    }
    ns.STAMP.initer.initDraw = _initDraw;
    ns.STAMP.initer.destroyDraw = _destroyDraw;
})(window);
